var bgPage = chrome.extension.getBackgroundPage();
var maxRecentlyClosedTabLength = 8;

var windowTabInfo = [];
var winID = [];
var activeWindowId;
var disableHistory = false;
var changeTabsOrder = false;
var ignorePinnedTabs = false;
var boldFont = false;
var disableGroupTabs = false;
var alwaysShowSearcher= true;

window.onload = function() {

    ///get setting options
        chrome.storage.sync.get({
            disableHistory: false,
            closed_tabs_number: 8,
            changeTabsOrder: false,
            ignorePinnedTabs: false,
            disableGroupTabs: false,
            alwaysShowSearcher: true
            }, function(items) {
                if(typeof items.disableHistory !== 'undefined') disableHistory = items.disableHistory;
                if(typeof items.closed_tabs_number !== 'undefined') maxRecentlyClosedTabLength = items.closed_tabs_number;
                if(typeof items.changeTabsOrder !== 'undefined') changeTabsOrder = items.changeTabsOrder;
                if(typeof items.ignorePinnedTabs !== 'undefined') ignorePinnedTabs = items.ignorePinnedTabs;
                if(typeof items.disableGroupTabs !== 'undefined') disableGroupTabs = items.disableGroupTabs;
                if(typeof items.alwaysShowSearcher !== 'undefined') alwaysShowSearcher = items.alwaysShowSearcher;
                // console.log("alwaysShowSearcher : " + alwaysShowSearcher);
                setTimeout(function(){
                    document.getElementById('loading').outerHTML= '';   
                    initialPage();
                },1);
        });

        (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
        (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
        m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
        })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');
        ga('create', 'UA-96433730-1', 'auto');
        ga('set', 'checkProtocolTask', function(){}); // Removes failing protocol check.
        ga('require', 'displayfeatures');
        ga('send', 'pageview', '/popup.html/v1.6.4');

}

var startIndex, endIndex, startWindowID, endWindowID, seletedTabID;

function initialPage(){

    document.getElementById('search-form').onsubmit = function(e){
        e.preventDefault();
    }

    if (alwaysShowSearcher){
        $('#search-form').addClass('search-form-show');
    }
    else{
        $('#search-form').addClass('search-form-hide');
    }

    ///add search bar
    // $('body').append('<div id="searchbar"><form><input type="text" id="searcher" class="searcher"><button> type="submit" class="submit_btn"></button></form></div>');

    chrome.windows.getCurrent(null, function(window){
        activeWindowId = window.id;
    });

    var tabNumCount = [];

    chrome.windows.getAll({populate:true},function(windows){
        
        windows = Change_Windows_Array_Order(windows);

        for(let i in windows){
            windowTabInfo[i] = classifyTabs(windows[i].tabs);
            winID[i] = windows[i].id;
            populateList(windowTabInfo[i], i);
        }

        if (windows.length == 1) {
            $('#windowID1').css({"display":"none"});
        }

        if (!disableHistory){
            if (bgPage.allClosedTab !== null) 
                populateRecentlyClosed(bgPage.allClosedTab);
        }

        addSearchFunctions();

        setTimeout(function(){
            SetPopupHeight(); //prevent popup window display in a wrong size.
        },300);  

        setTimeout(function(){
            SetPopupHeight(); //prevent popup window display in a wrong size.
        },800);      

        setTimeout(function(){
            SetPopupHeight(); //prevent popup window display in a wrong size.
        },1400);   
       
    });

    function jumpToTab(tabId){
        chrome.tabs.update(tabId, {active: true});
                
        //if this tab is not in the current window ==> jump to that window
        chrome.tabs.get(tabId, function(t){
            if (t.windowId !== activeWindowId){
                chrome.windows.update(t.windowId, {focused: true});
            }
        });

    }

    function addSearchFunctions(){
        let ResultsID;

        $('#searcher').keyup(function(e){
            let search_results = $('#searcher').val(); 
            if(e.keyCode == 13){
                ResultsID = Number($($('.icon_wrap:visible')[0]).children()[1].getAttribute("tabid"));
                jumpToTab(ResultsID);
                return;
            }
            else{
                searchContent(search_results);
            } 
        });
        $('#searcher').focus();
    }

    function searchContent(search_results){
        $('#search-form').css({"position":"relative","top":"0"});
                // let search_results = $('#searcher').val();      
                // console.log(search_results);
                if(search_results.length == 0){
                    updatePopup();
                } 
                else {
                    // Display_Original_Tab_Order('showAll');
                    $('.icon_wrap').css('display','none');
                    for (let t of $('.count')){     
                        let thisTabID = Number(t.getAttribute("tabID"));
                        if(thisTabID !== 0){
                            chrome.tabs.get(thisTabID,function(thisTabInfo){
                            // console.log(thisTabInfo.url);
                            let thisTabUrl=thisTabInfo.url;

                            if ( t.innerHTML.toLowerCase().indexOf(search_results) !== -1 || thisTabUrl.indexOf(search_results) !== -1){
                                // console.log(t.innerHTML.toLowerCase());
                                // console.log(t);
                                $(t).parent().css('display','block');
                            }
                        });
                        }
                        
                    }
                
        }
    }


    // console.log(windowTabInfo);
    // console.log(windowTabInfo.length);
    

    function updatePopup(){
        let last_search_results = $('#searcher').val(); 
        
        let bd = $('body').children();
        for (let i=1; i< bd.length; i++){
            if (bd[i].id.indexOf('win') > -1){
                bd[i].remove();
            }
        }

        chrome.windows.getCurrent(null, function(window){
            activeWindowId = window.id;
        });
        // $('body').children().remove();
        chrome.windows.getAll({populate:true},function(windows){

            windows = Change_Windows_Array_Order(windows);

            for(let i in windows){
                windowTabInfo[i] = classifyTabs(windows[i].tabs);
                let k = Number(i)+1;
                $('#win' + k).remove();
                populateList(windowTabInfo[i], i);               
            } 
            if (windows.length == 1) {
                $('#windowID1').css({"display":"none"});
            } 

            if (!disableHistory){
                updateClosedTab();
            }
            

            if(last_search_results.length !== 0){
            // console.log("serach content: " + last_search_results);
            // searchContent(last_search_results);
            $('#searcher').trigger('keyup');
            $('#searcher').focus();
            // $('#searcher').keyup();
            }
            else{
                console.log("no serach content");
            }
            
        });


        

    }

    function Change_Windows_Array_Order(windows){
        if (windows[0].id !== activeWindowId){
                for (let i in windows){
                    if (windows[i].id == activeWindowId){
                        let windowclone = windows[i];
                        windows.splice(i,1);
                        windows.splice(0,0,windowclone);
                        break;
                    }
                }
        }
        return windows;
    }

    function Display_Original_Tab_Order(tid){
        // $('body').children().remove();
        // $('body').append('<div id="searchbar"><form><input type="text" id="searcher" class="searcher"><button type="submit" class="submit_btn"></button></form></div>');

        chrome.windows.getAll({populate:true},function(windows){

            windows = Change_Windows_Array_Order(windows);

            for(let i in windows){
                let k = Number(i)+1;
                $('#win' + '100' + k).remove();
                windowTabInfo[i] = Get_Original_Tab_Order(windows[i].tabs,tid);
                
                // $('#win' + k).remove();
                $('#win' + k).css({"display": "none"});
                $('#closedTabs').remove();
                populateList(windowTabInfo[i], 100+i);               
            }  
            if (windows.length == 1) {
                $('#windowID1001').css({"display":"none"});
            }
            // if (!disableHistory){
            //     updateClosedTab();
            // }
            
        });
    }

    function Get_Original_Tab_Order(tabs,tid){
        let tab_data = [];
        for (let i = 0; i < tabs.length; i++) {
                if(tabs[i].id !== tid){
                    let info;
                    // console.log(tabs[i].url);
                    if(tabs[i].url.split('/')[2] !== undefined){

                        info = urlFilter(tabs[i].url.split('/')[2]);

                    }
                    else{
                        info = tabs[i].url;
                    }


                    let this_tab_favIconUrl = checkUrlValidation(tabs[i]); //assign a default icon if this favIconUrl is null
                    let this_tab_title = pageTitleFilter(tabs[i].title);
                    tab_data.push({  "favIconUrl" : this_tab_favIconUrl,
                                     "info": info,
                                     "id": [tabs[i].id],
                                     "title": [this_tab_title],
                                     "index": [tabs[i].index],
                                     "active": tabs[i].active
                                 });
                    tabNumCount.push(0);
                }          
        }
        return tab_data;
    }

    function updateClosedTab(){
        bgPage = chrome.extension.getBackgroundPage();
        if (bgPage.allClosedTab !== null) 
                populateRecentlyClosed(bgPage.allClosedTab);      
    }

    function pageTitleFilter(c){
        let n = c.indexOf('<');
        if ( n > -1 ){
            c = c.replace( /<[^>]+>/g, ''); //delete all < >, prevent HTML tag
        }
        while ( c.slice(0,1) == ' ' || c.slice(0,1) == '-'){
            c = c.slice(1);
        }
        return c;
    }

    function classifyTabs(tabs){
        let tab_data = [];
        
        ///classify tabs
        for (let i = 0; i < tabs.length; i++) {
                // console.log(tabs[i]);

                let already_exist = false;
                let info;
                    
                if (ignorePinnedTabs){
                    if(tabs[i].pinned) { continue; } 
                }
                //clssify tabs by url
                if(tabs[i].url !== undefined){
                    info = urlFilter(tabs[i].url);
                }
                else{
                    info = tabs[i].url;
                }
                

                for (let j=0; j<tab_data.length; j++){
                    if(!disableGroupTabs){
                        if (info == tab_data[j].info){   
                            already_exist = true;
                            tab_data[j].id.push(tabs[i].id);
                            tab_data[j].title.push(pageTitleFilter(tabs[i].title));
                            tab_data[j].index.push(tabs[i].index);
                            if (tab_data[j].active == false && tabs[i].active == true){
                                tab_data[j].active = true;
                            }
                            break;
                        }
                    }
                    
                }

                if (!already_exist){
                    let this_tab_favIconUrl = checkUrlValidation(tabs[i]); //assign a default icon if this favIconUrl is null
                    let this_tab_title = pageTitleFilter(tabs[i].title);
                    tab_data.push({  "favIconUrl" : this_tab_favIconUrl,
                                     "info": info,
                                     "id": [tabs[i].id],
                                     "title": [this_tab_title],
                                     "index": [tabs[i].index],
                                     "active": tabs[i].active
                                 });
                    tabNumCount.push(0);
                }

                tab_data.sort(function(a,b){
                    if(b.id.length == a.id.length){
                        return a.index[0] - b.index[0]
                    }
                    else{
                        return b.id.length - a.id.length;
                    }
                    
                });               
        }
        return tab_data;
    }

    
    
    function populateList(tab_data, windowID){

        windowID = Number(windowID) + 1;

        $('body').append('<div id="win' + windowID + '"><div id="windowID' + windowID+ '" class="windowID grabbable" draggable="true" style="margin-top:0;">Window '+ windowID%100 +'<div id="close_window' + windowID + '" class="close_window_icon"><img class="close_window_icon_img" src="images/closeIcon_red.png"/></div></div></div>');

        // Add close window function
        $("#close_window"+windowID).on('click',function(){
            for (let i in tab_data){
                for (let j of tab_data[i].id){
                    chrome.tabs.remove(j);
                } 
            }
            setTimeout(function(){         
                $("#win"+windowID).remove();
                bgPage = chrome.extension.getBackgroundPage();
                populateRecentlyClosed(bgPage.allClosedTab);
            },100);
        });

        let thisWindowWrapoer = $('#win'+ windowID);

        for (let i in tab_data){
            let text;
            let dragInfo = '';
            let thisTabId = 'tabId="';

            if(tab_data[i].id.length > 1){
                text = tab_data[i].id.length +' <span>tabs at</span> '+ tab_data[i].info;
                dragInfo = ' draggable="false"';
                thisTabId += '0"';
            }
            else{
                text = tab_data[i].title[0];
                dragInfo = ' draggable="true"'; //enable drag
                thisTabId += tab_data[i].id[0] + '"';
            }
            

            let thisElementID = windowID + '_' + i;
            var newIcon = '<div class="icon_wrap win'+ windowID +'" id="line' + thisElementID + '"' + dragInfo +'><img class="favicon" src=" ' + tab_data[i].favIconUrl + 
                '"/><div class="count" id="c' + thisElementID + '"' + thisTabId +'>'+ text +'</div><div class="close_icon" id="close' + thisElementID + '"><img class="close_img" src="images/xs.png"/></div></div>';  
            thisWindowWrapoer.append(newIcon);

            ///add an left green border to show current tab
            if (tab_data[i].active && windowID == 1){
                $('#line' + thisElementID).addClass('current_tab');
                $('#line' + thisElementID + ' img').css('padding-left','6px');
            }


            if(tab_data[i].id.length > 1){
                for (let j in tab_data[i].id){
                    let thisTabId = 'tabId="' + tab_data[i].id[j] + '"';
                
                    let thisID = tab_data[i].id[j];

                    newIcon = '<div class="icon_wrap hide icon_wrap_hide_' + thisElementID + '" id="line' + thisID + '" draggable="true"'
                    + '"><img class="favicon" src="images/right_arrow.png"/><div class="count" id="c' + thisID +'"'+ thisTabId +'>'
                    + tab_data[i].title[j] +'</div><div class="close_icon" id="close' + thisID + '"><img class="close_img" src="images/xs.png"/></div></div>';

                    thisWindowWrapoer.append(newIcon);  

                    chrome.tabs.get(thisID, function(t){     
                        if(t.active == true){ 
                            $('#line' + thisID).addClass('current_tab'); ///add an left green border to show current tab
                            $('#line' + thisID + ' img').css('padding-left','6px');
                        }
                    });

                    //////////////// drag events //////////////////
                    $('#line' + thisID).on("dragstart", function(event){
                        // console.log($(this).children()[1].getAttribute("tabid"));
                        console.log(tab_data[i]);
                        $(this).css({"opacity":"0.1"});
                        seletedTabID = tab_data[i].id[j];
                        startIndex = tab_data[i].index[0];
                        startWindowID = windowID - 1;
                        Display_Original_Tab_Order(Number($(this).children()[1].getAttribute("tabid")));
                    }); 

                    $('#line'+ thisID).on("dragend", function(event){
                        // console.log("drag end");
                        $(this).css({"opacity":"1"});
                        $('.icon_wrap').css({"padding-top":"0"});

                        ga('send', 'event', 'Button', 'drag', '#drag tab');//GA
                        setTimeout(function(){ updatePopup();},200); 

                    });

                    $('#line'+ thisID).on("dragover", function(event){
                        event.preventDefault(); 
                        if($(this).attr('draggable') == 'true'){
                            $(this).css({"padding-top":"25px"});
                            endIndex = tab_data[i].index[0];
                            
                            endWindowID = windowID%100 - 1;
                            newPosition = $(this);   
                            if ((startIndex !== endIndex || startWindowID !== endWindowID) && endIndex !== -1){
                                // console.log("tab moved " + tab_data[i].id[0]);
                                chrome.tabs.move(seletedTabID, { "windowId": winID[endWindowID], "index": endIndex });

                            }
                        }                   
                    });

                    $('#line'+ thisID).on("dragleave", function(event){
                        event.preventDefault(); 
                        $(this).css({"padding-top":"0"});
                    });

                    //////////////////end drag events/////////////////
                    

                    $('#c'+ thisID).on("click",function(){
                        jumpToTab(thisID);
                    });

                    ///Add CLICK EVENT for CLOSE button in 2nd hierarchy
                    $('#close'+ thisID).on("click", function(){
                        ga('send', 'event', 'Button', 'Click', '#close one tab in 2nd hierarchy');//GA

                        $(this).css('animation','quit 0.3s');
                        $('#line' + thisID).css('animation','lineShrink 0.3s');
                       
                        //if this is the last tab in this class
                        tabNumCount[i]++;
                        
                        if(tab_data[i].id.length == tabNumCount[i]){
                            setTimeout(function(){  
                                $('#line'+ thisElementID).remove();
                                updatePopup();  
                            },350);                  
                        }

                        chrome.tabs.remove(tab_data[i].id[j]);
                        
                        setTimeout(function(){         
                            $('#line'+ thisID).remove();
                            bgPage = chrome.extension.getBackgroundPage();
                            populateRecentlyClosed(bgPage.allClosedTab);
                        },320);
                            
                    });

                }
            }

            ///Functions for 1st hierarchy

            //CLICK AND JUMP TO PAGE
            $('#c'+ thisElementID).on("click",function(){

                if(tab_data[i].id.length > 1){
                    $( ".icon_wrap_hide_" + thisElementID ).toggle(); //expand tabs
                    ga('send', 'event', 'Button', 'Click', 'toggle');  
                    if (changeTabsOrder){
                        ///reorder tabs
                        let orderStart = tab_data[i].index[0];
                        for (let j of tab_data[i].id){   
                            chrome.tabs.move(j, { "index": orderStart });
                            orderStart ++;
                        }
                    }            
                }
                else{
                    ga('send', 'event', 'Button', 'Click', 'jump to page in multi-tabs');  
                    chrome.tabs.update(tab_data[i].id[0], {active: true});
                    chrome.tabs.get(tab_data[i].id[0], function(t){
                            if (t.windowId !== activeWindowId){
                                chrome.windows.update(t.windowId, {focused: true});
                            }
                        });
                }      
            });

            
            //DRAG evnets         
            var newPosition;

            $('#line'+ thisElementID).on("dragstart", function(event){
                // console.log($(this).children()[1].getAttribute("tabid"));
                console.log(tab_data[i]);
                $(this).css({"opacity":"0.1"});
                seletedTabID = tab_data[i].id[0];
                startIndex = tab_data[i].index[0];
                startWindowID = windowID - 1;
                // console.log(startWindowID);
                Display_Original_Tab_Order(Number($(this).children()[1].getAttribute("tabid")));
                
            });

            $('#line'+ thisElementID).on("dragend", function(event){
                // console.log("drag end");
                $(this).css({"opacity":"1"});
                $('.icon_wrap').css({"padding-top":"0"});

                ga('send', 'event', 'Button', 'drag', '#drag tab');//GA

                setTimeout(function(){updatePopup();},200); 

            });

            $('#line'+ thisElementID).on("dragover", function(event){
                event.preventDefault(); 
                if($(this).attr('draggable') == 'true'){
                    $(this).css({"padding-top":"25px"});
                    endIndex = tab_data[i].index[0];
                    endWindowID = windowID%100 - 1;
                    // newPosition = $(this);   
                    if ((startIndex !== endIndex || startWindowID !== endWindowID) && endIndex !== -1){
                        
                        chrome.tabs.move(seletedTabID, { "windowId": winID[endWindowID], "index": endIndex });

                    }
                }                   
            });

            $('#line'+ thisElementID).on("dragleave", function(event){
                event.preventDefault(); 
                $(this).css({"padding-top":"0"});
            });


            //CLOSE button events
            $('#close'+ thisElementID).on("click", function(){

                if (tab_data[i].id.length > 1){
                    ga('send', 'event', 'Button', 'Click', '#close multi tabs in line'+ i);
                }
                else{
                    ga('send', 'event', 'Button', 'Click', '#close one tab in line'+ i);
                }

                $(this).css('animation','quit 0.3s');
                $('#line'+ thisElementID).css('animation','lineShrink 0.3s');

                $('#c'+ thisElementID).html('');//prevent text float on the animation
                $( ".icon_wrap_hide_" + thisElementID ).remove();

                if (!disableHistory){
                    updatePopupAfterTabsRomoved(tab_data[i].id.length); //update popup after all tabs removed
                }

                

                

                setTimeout(function(){
                    for (let j of tab_data[i].id){   
                        chrome.tabs.remove(j);
                        $('#line'+ thisElementID).remove();

                        if (windowID > 1){
                            if ($('#win'+ windowID).children().length == 1){
                                // console.log('');
                                $('#win'+ windowID).remove();
                            }
                        }    
                    }
                },350); 
                
            });

            ///Drag and merge whole WINDOW
            if (windowID !== 1){
                $('#windowID' + windowID).on('dragstart',function(){
                    $(this).css({"background-color":"#8BC34A",
                                 "opacity":"0.5"});
                    startWindowID = windowID - 1;
                    $('.win' + windowID ).css('display', 'none');//hide all tabs in this window
                }); 


                $('#windowID' + windowID).on('dragend',function(){
                    $(this).css({"background-color":"#F5F5F5",
                                 "opacity":"1"});
                    $( '.win' + windowID ).css('display', 'block');//show all tabs in this window

                    $('.icon_wrap').css({"padding-top":"0"});
                    console.log(startWindowID);
                    console.log(endWindowID);

                    if ((startIndex !== endIndex || startWindowID !== endWindowID) && endIndex !== -1){
                        ga('send', 'event', 'Button', 'Click', 'Drag a window'); //GA
                        for (let k in tab_data){
                            for (let q of tab_data[k].id){
                                chrome.tabs.move(q, { "windowId": winID[endWindowID], "index": endIndex });
                            }
                        }
                        setTimeout(function(){
                            updatePopup();
                        },300);
                        
                        
                    }

                }); 

            }

        }//end for i

    }//end function populateList

    function populateRecentlyClosed(tabs){
        $('#closedTabs').remove();
        let t = [];
        for (let i in tabs){
            t.push(tabs[i]);
        }
        //sort all closed tab by time
        t.sort(function(a,b){
            return b.time - a.time;                   
        });      
        
        if (t.length > 0){
            $('body').append('<div id="closedTabs"><div class="windowID">Recently Closed Tabs<div id="delete_history' + '' + '" class="close_window_icon"><img class="close_window_icon_img" src="images/closeIcon_red.png"/></div></div></div>');
            $('#delete_history').on('click',function(){
                bgPage = chrome.extension.getBackgroundPage();
                bgPage.allClosedTab = {};
                updateClosedTab();  
            });

            var counter = 0;
            for (let j in t){
                counter++;
                let newLines;
                let favUrl = checkUrlValidation(t[j]);

                if (j == 0){         
                    newLines = '<div class="icon_wrap closedTabs" id="line' + t[j].tabId + '"><img class="favicon" src=" ' + favUrl + 
                    '"/><div class="count" id="c' + t[j].id + '">'+ t[j].title +'</div><img class="restore_img" src="images/restore.png"/></div>';  
                }
                else{
                    newLines = '<div class="icon_wrap closedTabs closedTabs_hide" id="line' + t[j].tabId + '"><img class="favicon" src=" ' + favUrl + 
                    '"/><div class="count" id="c' + t[j].id + '">'+ t[j].title +'</div><img class="restore_img" src="images/restore.png"/></div>';  
                }
                $('#closedTabs').append(newLines);
                $('#line'+ t[j].tabId).on('click',function(){
                    chrome.tabs.create({url : t[j].url});
                    bgPage.removeClosedTab(t[j].tabId);
                    //update
                    setTimeout(function(){updatePopup(); },300);
                });

                if (counter == maxRecentlyClosedTabLength) break;
            }

            if(t.length !== 1){
                $('#closedTabs').append('<div id="rencentlyClosed"><img class="downArrow_img" src="images/down_arrow.png" /></div>');
                $('#rencentlyClosed').on('click', function(){
                    $('.closedTabs_hide').toggle();
                    //display restore icon
                    $(this).remove();

                 });
            }
            
        }
       
   
    }

    function checkUrlValidation(thisTab){
        let thisTab_favIconUrl;

        if( (typeof thisTab.favIconUrl) == 'undefined' || thisTab.favIconUrl == "" || thisTab.favIconUrl == null){
                thisTab_favIconUrl = 'images/default.png';                        
        }
        else{
            if(thisTab.url.indexOf('chrome://') > -1){
                if(thisTab.url == 'chrome://extensions/'){
                    thisTab_favIconUrl = 'images/e.png';
                }
                else if(thisTab.url == 'chrome://settings/'){
                    thisTab_favIconUrl = 'images/sc.png';
                }
                else if(thisTab.url == 'chrome://history/'){
                    thisTab_favIconUrl = 'images/h.png';
                }
                else{
                    thisTab_favIconUrl = 'images/c.png';
                }
            }
            else{
                thisTab_favIconUrl = thisTab.favIconUrl;
            }
            
        }   


        return thisTab_favIconUrl;
    }

    function urlFilter(url){

        if (url.indexOf('www.') > -1 ){
            url = url.replace('www.','');
        }
        
        /// compatibilty with Tab Suspender Extensions
        if (url.indexOf('chrome-extension://klbibkeccnjlkjkiokjodocebajanakg/suspended.html') > -1){ //great suspender
            // console.log(url);
            url = url.split('&uri=')[1].split('/')[2];
            // console.log(url);
        }
        else if (url.indexOf('chrome-extension://fiabciakcmgepblmdkmemdbbkilneeeh/park.html') > -1){  //tab suspender
            url = decodeURIComponent(url.split('&url=')[1].split('&tabId=')[0]).split('/')[2];
        }
        else{
            if(url.split('/')[2] != undefined){
                url = url.split('/')[2];
            }
            
        }

        let websites_CN = ['taobao.com','tmall.com','youku.com','iqiyi.com','hupu.com','qq.com',
        '163.com','zuche.com','58.com','jd.com','dangdang.com','zhihu.com',
        'fanli.com','suning.com','vip.com','ctrip.com','jumei.com','baidu.com','cn.dealmoon.com','zh.wikipedia.org','douban.com',
        'sina.cn','sohu.com','bilibili.com','ifeng.com','mogujie.com','kaola.com','gome.com','mafengwo.cn','qunar.com'];
        
        let websites_CN_Displayname = ['taobao','tmall','youku','iqiyi','hupu','qq',
        '163','zuche','58','jd','dangdang','zhihu',
        'fanli','suning','vip','ctrip','jumei','baidu','dealmoon','wikipedia','douban',
        'sina','sohu','bilibili','ifeng','mogujie','kaola','gome','mafengwo','qunar'];
        
        let websites_EN = ['jquery.com','yahoo.com','softpedia.com'];
        

        for (let j in websites_CN.length){          
            if (url.indexOf(websites_CN[j]) > -1 
                && url.indexOf('mail') == -1 ){
                url = chrome.i18n.getMessage(websites_CN_Displayname[j]);
            }
        }

        for (let j of websites_EN){
            if (url.indexOf(j) > -1 && url.indexOf('mail') == -1 ){
                url = j;
            }
        }

        return url;
    }

    function updatePopupAfterTabsRomoved(n){
        let tabs_remove_counter = 0;
        tabs_remove_target = n; 

        chrome.tabs.onRemoved.addListener(function tabs_onRemovedListener(){
            tabs_remove_counter++;
            
            if (n == tabs_remove_counter){
                updateClosedTab();
                chrome.tabs.onRemoved.removeListener(tabs_onRemovedListener);
            }  
        });
          
    }

    function SetPopupHeight(){
        //Due to unknown reason, sometimes popup window display in a wrong size.
        //this function add an empty object and delete it.
        let emptyBlock = $('body').append('<div id="emptyBlock" style="height:1px; display:block;"></div>');
        setTimeout(function(){$('#emptyBlock').remove();},300);
        // console.log('resize');
    }    

    
}//end function intial page



